<template>
  <TitleScreen @setIsSinglePlayer="updateIsSinglePlayer($event)" v-if="showTitleScreen" />
  <div id="app" v-else>
      <TurnStatus
        v-if="numberOfSelectedPieces === maxNumberOfSelectedPieces"
        :turnCounter="turnCounter"
        :isPlayerOneTurn="isPlayerOneTurn"
      />
    <div class="app__content">
      <Menu
        @selectPiece="selectedPiece = $event"
        v-if="numberOfSelectedPieces < maxNumberOfSelectedPieces"
        :playerTurn="playerTurn"
      />
      <Board
        @addPiece="updateData($event)"
        @handleStatusMessage="statusPieceInfo = $event"
        :boardSelectedPiece="selectedPiece"
        :boardPlayerTurn="playerTurn"
        :maxNumberOfSelectedPieces="maxNumberOfSelectedPieces"
        :isSinglePlayer="isSinglePlayer"
      />
      <div class="status">
        <Status :pieceInfo="statusPieceInfo" :isPlayerOneTurn="playerTurn" />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { Component } from "vue-property-decorator";
import Board from "./components/Board.vue";
import Menu from "./components/Menu.vue";
import Status from "./components/Status.vue";
import TitleScreen from "./components/TitleScreen.vue";
import TurnStatus from "./components/TurnStatus.vue";
import { PieceName, PieceInfo } from "./models/pieceModels";
import { defaultPiece } from "./utilities/defaultPieceInfo";

@Component({
  components: {
    Board,
    Menu,
    Status,
    TitleScreen,
    TurnStatus
  }
})
export default class App extends Vue {
  private numberOfSelectedPieces: number = 0;
  private selectedPiece: PieceName | null = null;
  private playerTurn: boolean = Math.random() >= 0.5;
  private maxNumberOfSelectedPieces: number = 4;
  private statusPieceInfo: PieceInfo = defaultPiece;
  private isSinglePlayer: boolean = false;
  private showTitleScreen: boolean = true;
  private turnCounter: number = 1;

  updateData(playerTurn: boolean): void {
    this.numberOfSelectedPieces < this.maxNumberOfSelectedPieces && this.numberOfSelectedPieces++;
    this.playerTurn = playerTurn;
  }

  updateIsSinglePlayer(isSinglePlayer: boolean): void {
    this.isSinglePlayer = isSinglePlayer;
    this.showTitleScreen = false;
    this.playerTurn = isSinglePlayer ? true : Math.random() >= 0.5;
  }

  updateTurnCounter(isPlayerOneTurn: boolean): void {
    this.playerTurn = isPlayerOneTurn;
    this.turnCounter++;
  }
}
</script>

<style lang="scss">
#app {
  display: flex;
  flex-direction: column;
  align-items: center;
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  background-image: url("./assets/grass.png");
}

.app__content {
  display: flex;
  align-items: center;
}

.status {
  border: 1px solid black;
  padding: 1rem;
  height: 80px;
  width: 100px;
}
</style>
